<?php
if (!defined('ABSPATH')) {
    exit;
}
class Food_Online_Shortcode_Address {
    protected static $_instance = null;
    protected $is_active = false;
    public static $shortcode_order;
	public static $categories_raw;
    public function __construct() {
        add_shortcode('foodonline_address_validator', array($this, 'address_validator'));
        add_shortcode('foodonline_postcode_validator', array($this, 'postcode_validator'));

        add_shortcode('foodonline_minicart', array($this, 'minicart'));
        add_shortcode('foodonline_menu', array($this, 'menu'));
        add_shortcode('foodonline_side_category_menu', array($this, 'side_cat_menu'));
        add_shortcode('foodonline_top_category_menu', array($this, 'top_cat_menu'));

    }
    public static function instance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;

    }

    public function postcode_validator($atts) {
        if (is_admin()) {
            return;
        }
		  $options = shortcode_atts(array('show' => null, 'placement' => null), $atts);
		   $show = empty($options['show']) ? '' : sanitize_text_field( $options['show'] ) ;
		  $placement= empty($options['placement']) ? 'shortcode' : sanitize_text_field( $options['placement'] ) ;
        return fdoe_get_zip_form($show, $placement);
    }
    public function address_validator($atts) {
        if (is_admin()) {
            return;
        }
		 $options = shortcode_atts(array('show' => null, 'placement' => null), $atts);
		   $show = empty($options['show']) ? '' : sanitize_text_field( $options['show'] ) ;

		  $placement= empty(sanitize_text_field($options['placement'])) ? 'shortcode' : sanitize_text_field( $options['placement'] ) ;

		ob_start();
        echo fdoe_get_address_form($show, $placement);
		echo   fdoe_get_address_form_fractions( );
		return ob_get_clean();
    }
    public function top_cat_menu() {
        if (is_admin()) {
            return;
        }
        ob_start();
	echo fdoe_get_top_menu_pre();
        echo '<div id="fdoe_products_id" class="fdoe_menu_header fdoe-top-sticky fdoe-element">
								<ul class="nav nav-tabs fdoe-menu-2  " id="menu_headings" >
								</ul></div>';
        return ob_get_clean();
    }
    public function side_cat_menu() {
        if (is_admin()) {
            return;
        }
        ob_start();
        echo '	<div class="fdoe-element" id="fdoe-left-left-container"><div   id="menu_headings_2" ><h4 class="Category_heading">';
        echo __('Menu', 'fdoep');
        echo '</h4></div></div>';

        return ob_get_clean();
    }
 
    public function minicart($atts) {
        if (is_admin()) {
            return;
        }
        $this->is_active = true;

        $content = fdoe_output_minicart();
        return $content;
    }
    public function menu($atts) {
        if (is_admin()) {
            return;
        }
        $this->is_active = true;
        $options = shortcode_atts(array('categories' => null, 'tags' => null, 'orderby' => null, 'order' => null, 'ids' => null,), $atts);

        $args = array('status' => 'publish');
        $args+= empty($options['ids']) ? [] : ['include' => explode(",", $options['ids']) ];
        $args+= empty($options['order']) ? ['order' => 'ASC'] : ['order' => $options['order']];
        $args+= empty($options['tags']) ? [] : ['tag' => explode(",", $options['ids']) ];
        $args+= empty($options['categories']) ? [] : ['category' => explode(",", $options['categories']) ];
        if (wc_clean($options['orderby']) == 'price') {
            $args+= ['orderby' => 'meta_value_num'];
            $args+= ['meta_key' => '_price'];
        } else {
            $args+= empty($options['orderby']) ? ['orderby' => 'name'] : ['orderby' => $options['orderby']];
        }



        $cats_array = [];
        if (!empty($options['categories'])) {
            $pieces = explode(",", $options['categories']);
            foreach ($pieces as $piece) {
                $category = get_term_by('name', $piece, 'product_cat');
                if ($category !== false) {
                    $cat_id = $category->term_id;
                    $cats_array[] = $cat_id;
                } else {
                    $piece = str_replace(' ', '', $piece);
                    $category = get_term_by('slug', $piece, 'product_cat');
                    $cat_id = $category->term_id;
                    $cats_array[] = $cat_id;
                }
            }
            if (get_option('fdoe_is_prem', 'no') == 'no' && !empty(Food_Online::get_category_objects())) {
                $cats2 = Food_Online::get_category_objects();
                $cats_array_2 = array_column($cats2, 'cat_ID');
                // Fix for PHP 7.0.32-33 where array_column is broken
                if (empty($cats_array_2) && is_array($cats2)):
                    $cats_array_2 = array_map(function ($each) {
                        return $each->cat_ID;
                    }, $cats2);
                endif;
                $cats_array = array_intersect($cats_array_2, $cats_array);
            }
        } else {
            $cats = '';
        }


		self::save_shortcode_order($cats_array);
				self::set_category_objects($cats_array);

				$products_is = array();
				 do_action('fdoe_before_foodonline2_loop');
				 $array = array();
				 $dump = array();
				 $cats = self::get_category_objects();
			foreach($cats as $cat){
				$dump[] = $cat->slug;

			}
				$products_ids = wc_get_products(array( 'status'=>'publish', 'limit'=> 20, 'return' => 'objects', 'category'=> $dump ));



        foreach ($products_ids as $i) {
            $array[] = Food_Online_Product2::the_product($i);
        }






		$locs = array(
					  'cats' => $cats,
					  //'products' => $array,
					  //self::get_shortcode_order(),
					  );

		wp_localize_script( 'fdoe-order', 'fdoe_short', $locs );








        ob_start();

        $fdoe_color_back = get_option('fdoe_color_back', 'inherit');
        $menu_color_back = $fdoe_color_back == '' ? 'inherit' : $fdoe_color_back;
        $fdoe_border_color = get_option('fdoe_border_color', '#ddd');
        $menu_border_color = $fdoe_border_color == '' ? '#ddd' : $fdoe_border_color;
?>

<style>


#the_menu, #menu_headings, div.fdoe-item:hover  {background-color: <?php echo $menu_color_back; ?>;
}
#the_menu .fdoe-item{
	border-right-color: <?php echo $menu_border_color; ?>;
	border-bottom-color: <?php echo $menu_border_color; ?>;

}

#the_main_container  h5{
    margin-top: 1rem;
	margin-bottom: 1rem;
	margin-left: .2rem;
	margin-right: .2rem;
}


</style>


<?php

		echo fdoe_get_menu_pre();
        echo '<div class="container-fluid fdoe_main_container fdoe-shortcode-extern" id="the_main_container">';
        echo '<div class=" fdoe-less-gut" id="fdoe-left-container">';
        echo '<div class="fdoe">
			<div class="fdoe-products flex-container-column" id="the_menu">

			</div>
		</div>
	</div>

</div>';
        $content = ob_get_clean();

	?><script> var Food_Online_Items = <?php echo json_encode(array('products' => $array,)) ?>;</script><?php
        return ($content);
    }
    public static function save_shortcode_order($cats_array) {
        if (!isset(self::$shortcode_order)) {
            self::$shortcode_order = $cats_array;
        }
    }
    public static function get_shortcode_order() {
        return self::$shortcode_order;
    }
	public static function set_category_objects($cats_array) {
			if (!isset(self::$categories_raw)) {


				$taxonomy       = 'product_cat';
				$orderby        = 'include';//'name';
				$show_count     = 0; // 1 for yes, 0 for no
				$pad_counts     = 0; // 1 for yes, 0 for no
				$hierarchical   = 1; // 1 for yes, 0 for no
				$title          = '';
				$empty          = 0;
				$fields         = 'all';
				$includes = $cats_array;
				$args           = array(
					'taxonomy'                => $taxonomy,
					'orderby'                => $orderby,
					'show_count'                => $show_count,
					'pad_counts'                => $pad_counts,
					'hierarchical'                => $hierarchical,
					'title_li'                => $title,
					'hide_empty'                => $empty,
					'fields'                => $fields,
					'include' => $includes,
				);
				self::$categories_raw = get_categories($args);


				$do_image = (get_option('fdoe_is_prem', 'no') == 'yes' && get_option('fdoe_cat_image', 'no') == 'yes') ? true : false;
					foreach (self::$categories_raw as $fdoe_cat) {
						$term_children  = get_term_children(filter_var($fdoe_cat->term_id, FILTER_VALIDATE_INT) , filter_var('product_cat', FILTER_SANITIZE_STRING));
						$parent_count       = 0;
						$fdoe_cat->image    = false;

						$has_sub        = true;
						if (empty($term_children) || is_wp_error($term_children)) {
							$has_sub        = false;

						}else{
							foreach ($term_children as $child_cat) {
								$child = get_term($child_cat, 'product_cat');
							$parent_count       = $parent_count + $child ->count;

						}

						}
						$fdoe_cat->category_count_not_children = $fdoe_cat->category_count - $parent_count ;
						$fdoe_cat->has_sub         = $has_sub;

						if ($do_image){
							$thumbnail_id   = get_term_meta($fdoe_cat->term_id, 'thumbnail_id', true);
						$image          = wp_get_attachment_url($thumbnail_id);
						$fdoe_cat->image           = $image;
						}
					}

			}
			return;
		}
		// Return product categories
		public static function get_category_objects() {
			return self::$categories_raw;
		}

}
